//說明: 根據輸入值操作馬達動作，並設定停止方式
//注意: 馬達轉動會讓自走車移動，請先墊高自走車讓輪胎離地，再開始測試
#include <SPI.h>
#include "ozbot.h" 		//設定OZBOT
int iVelL, iVelR;  //左右輪控制參數
void setup() {
  while (!Serial);
}
void loop() {
  Serial.println("Enter Left Speed(-1024~1024)");
  DebugIn(iVelL);
  Serial.println(iVelL);
  Serial.println("Enter Right Speed(-1024~1024)");
  DebugIn(iVelR);
  Serial.println(iVelR);
  OzBot.SetVelLR(iVelL, iVelR);	// 設定左右輪轉速與方向
  Serial.println("0: Stop, 1: Brake");
  while (1) {
    if (Serial.available()) {
      char c = Serial.read();
      if (c == '0') {
        OzBot.StopDual();	//以Stop方式停止兩輪轉動
        break;
      }
      else if (c == '1') {
        OzBot.BrakeDual();	//以Brake方式停止兩輪轉動
        break;
      }
    }
  }
  while (Serial.available()) Serial.read();

}
void DebugIn(int &Speed)
{
  char Buffer[6], Index = 0;
  uint16_t timeout = 0;
  unsigned char CommandReceived = 0;
  while (1) {
    if (CommandReceived) {
      if (--timeout == 0) {
        Speed = atoi(Buffer);
        return;
      }
    }
    if (Serial.available()) {
      CommandReceived = 1;
      char c = Serial.read();
      if (((c >= '0') && (c <= '9')) || (c == '-')) {
        Buffer[Index] = c;
        if (++Index >= sizeof(Buffer)) {
          break;
        }
      }
      else {
        break;
      }
    }
  }
  Speed = 0;
  while (Serial.available()) Serial.read();
  return;
}

