#include <SPI.h>
#include "ozbot.h"
#define Button_1 	  9 //定義按鈕腳位
#define Button_2 	  8
#define CAL_DZ_SPEED_L    230  //定義 校正時使用度
#define CAL_DZ_SPEED_R    230
int16_t iSecLenL, iSecLenR;
int16_t DeadZoneL, DeadZoneR;
void setup() {
  pinMode(Button_1, INPUT);
  pinMode(Button_2, INPUT);
  digitalWrite(Button_1, HIGH);
  digitalWrite(Button_2, HIGH);      
}
void loop() {
  if (digitalRead(Button_1) == LOW) {
    OzBot.CursorRC(2, 1);
    OzBot.ShowString("CAL IR!");
    IRCal();
    OzBot.CursorRC(2, 1);
    OzBot.ShowString("CAL OK!");
  }
  if (digitalRead(Button_2) == LOW) {
    OzBot.CursorRC(2, 1);
    OzBot.ShowString("CAL DZ!");
    CalDeadZone();
    OzBot.CursorRC(2, 1);
    OzBot.ShowString("CAL OK!");
  }
}
void IRCal(void) {
  delay(1000);
  OzBot.SetVelLR(150, -150); //啟動輪胎旋轉
  OzBot.IrCal(1);	     //啟動校正模式 1 (10秒)
  delay(5000);
  delay(5000);
  OzBot.StopDual();
}
void CalDeadZone() {
  OzBot.Beep();	//啟動蜂鳴器
  delay(1000);
  //取得校正速度DeadZone
  OzBot.GetMotorDeadZone(DeadZoneL, DeadZoneR);
  //設定速度，將初始速度加入校正速度
  iSecLenL = CAL_DZ_SPEED_L + DeadZoneL;
  iSecLenR = CAL_DZ_SPEED_R + DeadZoneR;
  //前進2秒，並取得左右輪差
  OzBot.ForwardLR(iSecLenL, iSecLenR);
  delay(500);
  OzBot.SetTachInLR(0, 0);
  delay(2000);
  OzBot.TachInDual(iSecLenL, iSecLenR);
  OzBot.StopDual();
  //依照左右輪差值，調整校正速度DeadZone
  iSecLenR = (iSecLenL - iSecLenR) / 16;
  if (iSecLenR > 80 ) {
    iSecLenR = 80;
  }
  else if (iSecLenR < -80 ) {
    iSecLenR = -80;
  }
  if (iSecLenR >= 0) {
    DeadZoneR = DeadZoneR + iSecLenR;
  }
  else {
    DeadZoneL = DeadZoneL - iSecLenR;
  }
  if (DeadZoneL >= DeadZoneR) {
    DeadZoneL = DeadZoneL - DeadZoneR;
    DeadZoneR = 0;
  }
  else {
    DeadZoneR = DeadZoneR - DeadZoneL;
    DeadZoneL = 0;
  }
  //將校正速度DeadZone存入記憶體中
  OzBot.SetMotorDeadZone(DeadZoneL, DeadZoneR);
}

