#include "arduino.h"
#include <SPI.h>
#ifndef OZBOT
#define OZBOT
class mOzBot {
public:  
  mOzBot(); 
  void SetP(uint8_t);
  void SetI(uint8_t);
  void SetD(uint8_t);
  void SetScalar(uint8_t);  
  
  void GetIrCal(unsigned char, uint16_t&, uint16_t&);
  void SetIrThreshold(uint8_t);
  void GetIr(uint8_t&);
  void GetAnalogIr(uint8_t, uint16_t&);  
  
  void SetIrMode(uint8_t);    
  void SetErrScale(unsigned char, unsigned char, unsigned char, unsigned char);    
  
  void SetCtrlFreq(unsigned char);
  void SetSpdCtrlL(int16_t, int16_t);    
  void SetSpdCtrlR(int16_t, int16_t);    
  void SetCrossCount(uint16_t);
  void SetLineColor(uint8_t); 
 
  void Beep(void);
  void AutoBeep(uint8_t);
  void SetStraight(int16_t, int16_t);
  
  void GetTotalPathCnt(unsigned char&);
  void TotalPath(uint8_t, uint8_t&, uint8_t&, uint8_t&,int16_t&, int16_t&);
  void GetOptiPathCnt(unsigned char&); 
  void OptimumPath(uint8_t, uint8_t&, uint8_t&, uint8_t&,int16_t&, int16_t&);
 
  void SearchPath(uint8_t);   
  
  void StartRec(uint8_t);
  void StopRec(void);
  void SpdCtrlOn(uint8_t);
  void SpdCtrlOff(void);  
  void GetSecCnt(uint8_t&);
  void GetRecStatus(uint8_t&);

  void TachInL(int16_t&);
  void TachInR(int16_t&);    
  void TachInDual(int16_t&, int16_t&);

  void ForwardDual(uint16_t);
  void BackwardDual(uint16_t);  
  void BrakeDual(void);  
  void StopDual(void); 
  void ForwardL(uint16_t);
  void ForwardR(uint16_t);
  void ForwardLR(uint16_t, uint16_t);  
  void BackwardL(uint16_t);  
  void BackwardR(uint16_t);      
  void BackwardLR(uint16_t, uint16_t);  
  void SetTachInLR(int16_t, int16_t);
  void SetVelLR(int16_t, int16_t);
  void IrCal(uint8_t);
  
  void GetCurSecTACH(int16_t&, int16_t&); 
  
  void GetSecDir(uint8_t, uint8_t&);
  void GetSecLen(uint8_t, int16_t&, int16_t&);    
  
  void ArcTurnControlL(uint8_t, int16_t, int16_t, int16_t, int16_t);
  void ArcTurnControlR(uint8_t, int16_t, int16_t, int16_t, int16_t);
  void RecTurnControlL(uint8_t, int16_t, int16_t, int16_t, int16_t);
  void RecTurnControlR(uint8_t, int16_t, int16_t, int16_t, int16_t);
  
  void SetMotorDeadZone(int16_t, int16_t);
  void GetMotorDeadZone(int16_t&, int16_t&);    
 // Lcd 
  void Display(uint8_t);
  void Display(int8_t);  
  void Display(uint16_t);
  void Display(int16_t);    
  void DisplayChar(uint8_t);  
  void CursorRC(uint8_t, uint8_t);
  void CursorRow(uint8_t);
  void CursorCol(uint8_t);
  void ClearEOL(void);  
  void CR(void); 
  void BackLightOn(uint8_t);
  void BackLightOff(void);
  void DisplayOn(void);
  void DisplayOff(void);
  void CursorOn(void);
  void CursorOff(void);      
  void Clear(void);
  void Home(void);
  void ShowString(char *);
  void Display(char *);    
// Battery
  unsigned char CheckLowBattery(void);
  void LowBatteryAlarmOn(void);
  void LowBatteryAlarmOff(void);
// Acc 
  void AccCal(void);
  void GyroCal(void);
  void SetAccMode(uint8_t); 
// Gyro
  void SetGyroMode(uint8_t);

  void GetGyroXADVal(uint16_t&);
  void GetGyroYADVal(uint16_t&);
  void GetGyroZADVal(uint16_t&);

  void GetAccX(int16_t&);
  void GetAccY(int16_t&);
  void GetAccZ(int16_t&);
  void GetAccXYZ(int16_t&, int16_t&, int16_t&);
    
  void GetGyroX(int16_t&);
  void GetGyroY(int16_t&);
  void GetGyroZ(int16_t&);
  void GetGyroXYZ(int16_t&, int16_t&, int16_t&);      
  void GetAccMaxMinX(int16_t&, int16_t&);                                                                                                                                   
  void GetAccMaxMinY(int16_t&, int16_t&);                                                                                                                                  
  void GetAccMaxMinZ(int16_t&, int16_t&);                                                                                                                                  
  void GetGyroIntegX(int32_t&);                                                                                                                                  
  void GetGyroIntegY(int32_t&);                                                                                                                                 
  void GetGyroIntegZ(int32_t&);                                                                                                                                 
  void GetGyroMaxMinX(int16_t&, int16_t&);                                                                                                                                
  void GetGyroMaxMinY(int16_t&, int16_t&);                                                                                                                                 
  void GetGyroMaxMinZ(int16_t&, int16_t&);    
  
// Compass  
  void CompassCal(uint8_t);
  uint8_t GetCompass(uint16_t&);
  void GetCompX(int16_t&);
  void GetCompY(int16_t&);
  void GetCompZ(int16_t&);
  void GetCompDevAngle(uint16_t &);
  void SetCompTargetAngle(uint16_t);
  void SetCompCurrentTargetAngle(void); 
// Sonar
  void Ranging(uint8_t);
  void RepeatRanging(void);
  void StopRanging(void);
  void GetDistance(uint8_t&, uint8_t&, uint8_t&, uint8_t&, uint8_t&);
   
private:
  unsigned char writeRegister(unsigned char, unsigned char Skip=0);
  unsigned char readRegister(unsigned char, unsigned char);
  uint8_t Cmd[16], DataBuf[8];  
};
#define kRetry      40  // 
#define kDelay      20  // us
#define kCmdDelay   500 // us
extern mOzBot OzBot;
#endif
